<?php
/*
*-------------------------------phpMyBitTorrent--------------------------------*
*--- The Ultimate BitTorrent Tracker and BMS (Bittorrent Management System) ---*
*--------------   Created By Antonio Anzivino (aka DJ Echelon)   --------------*
*-------------               http://www.p2pmania.it               -------------*
*----------         Developed By Emad Hossam (aka emadness)          ----------*
*-------------               http://www.fulldls.com               -------------*
*------------ Based on the Bit Torrent Protocol made by Bram Cohen ------------*
*-------------              http://www.bittorrent.com             -------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*--   This program is free software; you can redistribute it and/or modify   --*
*--   it under the terms of the GNU General Public License as published by   --*
*--   the Free Software Foundation; either version 2 of the License, or      --*
*--   (at your option) any later version.                                    --*
*--                                                                          --*
*--   This program is distributed in the hope that it will be useful,        --*
*--   but WITHOUT ANY WARRANTY; without even the implied warranty of         --*
*--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          --*
*--   GNU General Public License for more details.                           --*
*--                                                                          --*
*--   You should have received a copy of the GNU General Public License      --*
*--   along with this program; if not, write to the Free Software            --*
*-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA --*
                                                                             --*
*------------------------------------------------------------------------------*
*------              2005 phpMyBitTorrent Development Team              ------*
*-----------               http://phpmybittorrent.com               -----------*
*------------------------------------------------------------------------------*
*/

// This file contains Bit Torrent main functions. MUST be included before every
// other file at the beginning of any script
if (eregi("functions.php",$_SERVER['PHP_SELF'])) die("You can't access this file directly");
if (!function_exists("sha1")) require_once("include/sha1lib.php");
require_once("include/benc.php");


/*---------------------------------
ERROR HANDLING FUNCTIONS
----------------------------------*/

function btsqlerror(const $sql) { //Returns SQL Error
        global $db, $table2open, $tableopen;
        $err = Array();
        $err = $db->sql_error();
        OpenErrTable("SQL Error");
        echo(_btsqlerror1.$sql);
        echo("<BR>");
        echo(_btsqlerror2.$err["code"]);
        echo("<BR>");
        echo(_btsqlerror3.$err["message"]);
        CloseErrTable();
        if ($table2open) CloseTable2();
        if ($tableopen) CloseTable();
        include("footer.php");
        die();
}
function bterror(const $error, $title = _btgenerror) {
        global $table2open,$tableopen;
        OpenErrTable($title);
        if (is_array($error)) {
                echo _btalertmsg;
                echo "<UL>";
                foreach ($error as $msg) {
                        echo "<LI>".$msg."</LI>";
                }
                echo "</UL>";
        }else {
                 echo "<p class=\"errortext\">".$error."</p>";
        }
        echo "<p class=\"errortext\">"._btgoback."</p>";
        CloseErrTable();
        if ($table2open) CloseTable2();
        if ($tableopen) CloseTable();
        include("footer.php");
        die();
}
function loginrequired($level) {
        global $tableopen, $tableopen2, $btuser;
        $loginbox = "<form method=\"POST\" action=\"login.php\"><input type=\"hidden\" name=\"op\" value=\"login\">\n
        <p align=\"center\">"._btusername."<br><input type=\"text\" name=\"username\" size=\"20\">\n<br>"._btpassword."<br><input type=\"password\" name=\"password\" size=\"20\"></p>\n
        <p><input type=\"submit\" value=\""._btlogin."\"></p></form>";
        Header("HTTP/1.1 401 Unauthorized");
        OpenErrTable(_btaccdenied);
        switch ($level) {
                case "user": {
                        echo _btdenuser;
                        echo $loginbox;
                        break;
                }
                case "premium": {
                        echo _btdenpremium;
                        if (!is_user($btuser)) echo _btdenpremium1.$loginbox;
                        else echo _btdenpremium2;
                        break;
                }
                case "admin": {
                        echo _btdenadmin;
                        if (!is_user($btuser)) echo _btdenadmin1.$loginbox;
                        else echo _btdenadmin2;
                        break;
                }
                default: {
                        echo("Fatal Error!");
                        break;
                }
        }
        CloseErrTable();
        if($opentable2) CloseTable2();
        if($opentable) CloseTable();
        include("footer.php");
        die();
}

function logtorrent(const $action, const $torrent) {
        global $db, $btuser;
        if (is_user($btuser)) {
                $id_user  = getuserid($btuser);
                $username = getusername($btuser);
        } else {
                $id_user = 0;
                $username = "Anonymous";
        }
        $ip = ip2long($_SERVER['REMOTE_ADDR']);
        $host = gethostbyaddr($_SERVER['REMOTE_ADDR']);
        $qry = $db->sql_query("INSERT INTO torrent_log (uid , user , azione , torrent , data_ora , ip , host) VALUES ('".$id_user."', '".$username."', '".$azione."', '".$torrent."', NOW( ) , '".$ip."', '".$host."');");
        if (!$qry) {
                btsqlerror("Unable to write log");
        }

}

/*---------------------------------
SECURITY FUNCTIONS
---------------------------------*/

function is_user(const $user) { //Authenticates current user
    global $db;
    if(!is_array($user)) {
        $user = base64_decode($user);
        $user = addslashes($user);
        $user = explode("", $user);
    }
    $uid = $user[0];
    $username = $user[1];
    $pwd = $user[2];
    $act_key = $user[3];
    $uid = intval($uid);
    if ($uid != "" AND $pwd != "") {
        $result = $db->sql_query("SELECT id FROM torrent_users WHERE id = '".$uid."' AND username = '".escape($username)."' AND password = '".escape($pwd)."' AND act_key = '".escape($act_key)."';");
        if($db->sql_numrows($result) == 1) {
            return true;
        }
    }
    return false;
}

function is_btadmin(const $user) { //Returns true if the user is a Bit Torrent or Super Administrator
    global $db;
    if (!is_user($user)) return_false;
    if(!is_array($user)) {
        $user = base64_decode($user);
        $user = addslashes($user);
        $user = explode("", $user);
    }
    $uid = $user[0];

    if ($uid != "") {
        $result = $db->sql_query("SELECT id FROM torrent_users WHERE id = '".$uid."' AND level = 'admin';");
        if ($db->sql_numrows($result) == 1) {
                return true;
        }
    }
    return false;
}
function is_premium(const $user) {
        global $db;
        if (!is_user($user)) return false;
        if (is_btadmin($user)) return true;
        $sql = "SELECT id FROM torrent_users WHERE id = '".getuserid($user)."' AND level = 'premium';";
        $res = $db->sql_query($sql) or btsqlerror($sql);
        if ($db->sql_numrows($res) == 1) {
                return true;
        }
        return false;
}
function can_download(const $user, &$torrent) {
        if (is_premium($user)) return true;
        global $db, $download_level, $torrent_global_privacy;
        if ($download_level == "all") return true;
        if ($download_level == "premium" AND !is_premium($user)) return false;
        if ($download_level == "user" AND !is_user($user)) return false;
        if ($download_level == "user" AND !$torrent_global_privacy) return true;
        if ($download_level == "user" AND $torrent_global_privacy) {
                if ($torrent["ownertype"] == 2) return true;
                $sql = "SELECT status FROM torrent_privacy_global WHERE master = '".$torrent["owner"]."' AND slave = '".getuserid($user)."';";
                $privacylist = $db->sql_query($sql) or btsqlerror($sql);
                if ($db->sql_numrows($privacylist) == 1) {
                        $privacy = $db->sql_fetchrow($privacylist);
                        if ($privacy["status"] == "whitelist") return true;
                        else return false;
                }
                $sql = "SELECT status FROM torrent_privacy_file WHERE slave = '".getuserid($user)."' AND torrent = '".$torrent["id"]."';";
                $authqry = $db->sql_query($sql) or btsqlerror($sql);
                if ($db->sql_numrows($authqry) == 0) return false;
                $authrow = $db->sql_fetchrow($authqry);
                if ($authrow["status"] == "granted") return true;
                else return false;
        }
}
function userlogin(const $username, &$cookiedata) {
        global $db, $cookiedomain, $cookiepath;
        $res = $db->sql_query("SELECT * FROM torrent_users WHERE username ='".escape($username)."';");
        if (!$res) return;
        $row = $db->sql_fetchrow($res);
        if (!$row) return;
        $cookiedata = base64_encode(implode("",Array($row["id"],$row["username"],$row["password"],$row["act_key"])));
        setcookie("btuser",$cookiedata,time()+1000000000,$cookiepath,$cookiedomain,0);
        return;
}
function getuserid(const $user) { //Gets the user ID from cookie
        if (!is_user($user)) return 0;
        $userdata = base64_decode($user);
        $userdata = explode("", $userdata);
        return $userdata[0];
}

function getusername(const $user) { //Gets the user name from cookie
        if (!is_user($user)) return "Anonymous";
        $userdata = base64_decode($user);
        $userdata = explode("", $userdata);
        return $userdata[1];
}
function is_email(const $email) {
        return preg_match("/^(([A-Za-z0-9]+_+)|([A-Za-z0-9]+\\-+)|([A-Za-z0-9]+\\.+)|([A-Za-z0-9]+\\++))*[A-Za-z0-9]+@((\\w+\\-+)|(\\w+\\.))*\\w{1,63}\\.[a-zA-Z]{2,6}$/",$email);
}
function is_filename(const $name) { //Is the file name valid?
        return preg_match('/^[^\0-\x1f:\\\\\/?*\xff#<>|]+$/si', $name);
}
/*
function validemail($email) { //Is the e-mail address valid?
        return preg_match('/^[\w.-]+@([\w.-]+\.)+[a-z]{2,6}$/is', $email);
}
*/
function escape(const $x) { //Like mysql_escape_string()
        return str_replace("'", "\'", $x);
}
function unescape(const $x) {
        return str_replace("\'", "'", $x);
}
function sqlwildcardesc(const $x) { //Replaces wildcards
        return str_replace(array("%","_"), array("\\%","\\_"), str_replace("'", "''", $x));
}

function RandomNum(const $num) {
        $set = "0123456789";
        $resp = "";
        for ($i=1; $i<=$num; $i++) {
                $char = rand(0,strlen($set));
                $resp.=$set[$char];
        }
        return $resp;
}
function RandomAlpha(const $num) {
        $set = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvxyz0123456789";
        $resp = "";
        for ($i=1; $i<=$num; $i++) {
                $char = rand(0,strlen($set));
                $resp.=$set[$char];
        }
        return $resp;
}
function spellmail(const $email) {
        $search = Array("@",".");
        $replace = Array(_at,_dot);
        return "<i>".str_replace($search,$replace,$email)."</i>";
}


/*---------------------------------
MAINTENANCE FUNCTIONS
----------------------------------*/

function autoclean() { //Cleans the database up
        global $autoclean_interval;

        $now = time();
        $docleanup = 0;

        $res = $db->sql_query("SELECT value_u FROM torrent_avps WHERE arg = 'lastcleantime'");
        $row = $db->sql_fetchrow($res);
        if (!$row) {
                $db->sql_query("INSERT INTO torrent_avps (arg, value_u) VALUES ('lastcleantime',$now)");
                return;
        }
        $ts = $row[0];
        if ($ts + $autoclean_interval > $now)
                return;
        $ret = $db->sql_query("UPDATE torrent_avps SET value_u=$now WHERE arg='lastcleantime' AND value_u = $ts");
        if (!$db->sql_numrows($ret))
                return;

        docleanup();
}

function deadtime() { //Unknown. Must be dropped
        global $announce_interval;
        return time() - floor($announce_interval * 1.3);
}

/*---------------------------------
TEXT & GRAPHICS FUNCTIONS
----------------------------------*/

function unesc($x) { //Useful for escaping strings
        if (get_magic_quotes_gpc())
                return stripslashes($x);
        return $x;
}

function mksize($s) { //Byte, Kilobyte, Megabyte, Gigabyte size
        $x = 3;
        $a = array("","k","M","G");
        for (;;) {
                $v = pow(1024, $x);
                if (!$x || $s >= $v) {
                        $ss = sprintf("%.".$x."f", ($s / $v));
                        $xx = $ss . " " . $a[$x] . "B";
                        break;
                }
                $x--;
        }
        return $xx;
}
function formatTimestamp(const $time) {//Formats date & time
    global $datetime, $locale;
    setlocale (LC_TIME, $locale);
    ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $datetime);
    $datetime = strftime(""._DATESTRING."", mktime($datetime[4],$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]));
    $datetime = ucfirst($datetime);
    return($datetime);
}

function mkprettytime($s) {//Formats date&time?
        if ($s < 0)
                $s = 0;
        $t = array();
        foreach (array("60:sec","60:min","24:hour","0:day") as $x) {
                $y = explode(":", $x);
                if ($y[0] > 1) {
                        $v = $s % $y[0];
                        $s = floor($s / $y[0]);
                }
                else
                        $v = $s;
                $t[$y[1]] = $v;
        }

        if ($t["day"])
                return $t["day"]._btdays.", ".$t["hour"]._bthours. $t["min"]._btmins.$t["sec"]._btsecs;
        if ($t["hour"])
                return $t["hour"]._bthours. $t["min"]._btmins. $t["sec"]._btsecs;
        if ($t["min"])
                return $t["min"]._btmins. $t["sec"]._btsecs;
        return $t["sec"]. _btsecs;
}

function urlparse($m) { //Makes URLs clickable
        $t = $m[0];
        if (preg_match(',^\w+://,', $t))
                return "<a href=\"".$t."\">".$t."</a>";
        return "<a href=\"http://".$t."\">".$t."</a>";
}
function parsedescr($d) { //Parses Torrent description
        $pd = str_replace(array("\n", "\r"), array("<br />\n", ""), htmlspecialchars($d));
        $pd = preg_replace_callback('(\w+://([^\s/:@]+(:[^\s/:@]++)?@)?|\bwww\.)[\w.-]+(:\d+)?(/[-\w=./?&%+#;|@]*)?[0-9a-z/]is', "urlparse", $pd);
        return $pd;
}
function catlist() {
        global $db;
        $ret = array();
        if(! $res = $db->sql_query("SELECT id, name FROM torrent_categories ORDER BY sort_index, id ASC") )
                bterror("SELECT id, name FROM torrent_categories ORDER BY sort_index, id ASC");
        while ($row = $db->sql_fetchrow($res))
                $ret[] = $row;
        return $ret;
}
function pic(const $name, $url = "") {//Gets a picture from theme directory
        global $theme;
        $ret = "<img src=\"themes/".$theme."/pics/".$name."\" border=\"0\">";
        if ($url != "") {
                return "<a href=\"".$url."\">".$ret."</a>";
        }
        return $ret;
}
function ratingpic($num) {//Gets the correct star rating picture
        global $pic_base_url;
        $r = round($num * 2) / 2;
        if ($r < 1 || $r > 5)
                return;
        return pic($r.".gif");
}

?>
